'"<$fbc>" -dll "<$file>" -x ..\ARBShaderPlugin.dll
#include "windows.bi"
#include "fbgfx.bi"
#include "GL/gl.bi"
#include "GL/glext.bi"
#include "Basic4GLMacros.bi"

const PLUG_DESC = "for Basic4GL"
const PLUG_MAJOR = 0
const PLUG_MINOR = 1

dim shared as IDLL_Basic4GL_Plugin ptr Plugin
dim shared as string gLastError
dim shared as integer gIsInit

DIM shared wglSwapIntervalEXT as sub(enable as integer)

#define DIMGP(name) DIM SHARED name AS PFN##name##PROC

#define LGP(name) name = cptr(PFN##name##PROC, wglGetProcAddress(#name))

DIMGP(glCreateShaderObjectARB)
DIMGP(glShaderSourceARB)
DIMGP(glCompileShaderARB)
DIMGP(glDeleteObjectARB)
DIMGP(glCreateProgramObjectARB)
DIMGP(glAttachObjectARB)
DIMGP(glDetachObjectARB)
DIMGP(glUseProgramObjectARB)
DIMGP(glLinkProgramARB)
DIMGP(glValidateProgramARB)
DIMGP(glGetInfoLogARB)
DIMGP(glGetShaderSourceARB)
DIMGP(glGetAttachedObjectsARB)

DIMGP(glGetObjectParameterivARB)
DIMGP(glGetObjectParameterfvARB)

DIMGP(glGetActiveUniformARB)
DIMGP(glGetUniformLocationARB)

DIMGP(glUniform1fARB)
DIMGP(glUniform2fARB)
DIMGP(glUniform3fARB)
DIMGP(glUniform4fARB)

DIMGP(glUniform1iARB)
DIMGP(glUniform2iARB)
DIMGP(glUniform3iARB)
DIMGP(glUniform4iARB)

DIMGP(glUniform1fvARB)
DIMGP(glUniform2fvARB)
DIMGP(glUniform3fvARB)
DIMGP(glUniform4fvARB)

DIMGP(glUniform1ivARB)
DIMGP(glUniform2ivARB)
DIMGP(glUniform3ivARB)
DIMGP(glUniform4ivARB)

DIMGP(glUniformMatrix2fvARB)
DIMGP(glUniformMatrix3fvARB)
DIMGP(glUniformMatrix4fvARB)

DIMGP(glGetUniformfvARB)
DIMGP(glGetUniformivARB)



extern "C"

DPF(ShaderInit)
  SIR(gIsInit<>0)
end sub

DPF(CompileStatus) ' if CompileError(hShader) then
  dim as integer ret
  glGetObjectParameterivARB(GIP(1),GL_OBJECT_COMPILE_STATUS_ARB,@ret)
  SIR(ret)
end sub
DPF(LinkStatus) ' if LinkError(hProgram) then
  dim as integer ret
  glGetObjectParameterivARB(GIP(1),GL_OBJECT_LINK_STATUS_ARB,@ret)
  SIR(ret)
end sub
DPF(ValidateStatus) ' if ValidatekError(hProgram) then
  dim as integer ret
  glGetObjectParameterivARB(GIP(1),GL_OBJECT_VALIDATE_STATUS_ARB,@ret)
  SIR(ret)
end sub

DPF(GetInfoLog) ' txt$=GetInfoLog(hObject)
  dim as integer size
  glGetObjectParameterivARB(GIP(1), GL_OBJECT_INFO_LOG_LENGTH_ARB , @size)
  if size>0 then
    dim as zstring ptr msg=callocate(size)
    dim as integer retlen
    glGetInfoLogARB(GIP(1),size, @retlen,msg)
    SSR(msg)
  end if
end sub

DPF(GetActiveUniforms)' count=(hProgram)
  dim as integer count
  glGetObjectParameterivARB(GIP(1),GL_OBJECT_ACTIVE_UNIFORMS_ARB,@count)
  SIR(count)
end sub

DPF(GetUniformName)' name$=(hProgram,number)
  dim as integer maxsize
  glGetObjectParameterivARB(GIP(2),GL_ACTIVE_UNIFORM_MAX_LENGTH,@maxsize)
  if maxsize>0 then 
    dim as zstring ptr pName=callocate(maxsize)
    dim as integer     rSize,rType
    glGetActiveUniformARB(GIP(2),GIP(1),maxsize,NULL,@rSize,@rType,pName)
    SSR(pName)
    deallocate(pName)
  end if
end sub

DPF(GetUniformType)' type=(hProgram,number)
  dim as integer maxsize
  glGetObjectParameterivARB(GIP(2),GL_ACTIVE_UNIFORM_MAX_LENGTH,@maxsize)
  if maxsize>0 then 
    dim as zstring ptr pName=callocate(maxsize)
    dim as integer     rSize,rType
    glGetActiveUniformARB(GIP(2),GIP(1),maxsize,NULL,@rSize,@rType,pName)
    deallocate(pName)
    SIR(rType)
  end if
end sub




DPF(CreateShaderObjectARB) ' hShader=
  if gIsInit then
    SIR(glCreateShaderObjectARB(GIP(1)))
  else
    SIR(0)
  end if
end sub

DPF(CreateProgramObjectARB) 'hProgram=
  if gIsInit then
    SIR(glCreateProgramObjectARB())
  end if
end sub

DPF(DeleteObjectARB) ' hObject
  if gIsInit then
    glDeleteObjectARB(GIP(1))
  end if
end sub

DPF(ShaderSourceARB)' hShader,Code$
  if gIsInit then
    dim as zstring ptr pArray(0)
    pArray(0)=GSP(1)
    glShaderSourceARB(GIP(2),1,@pArray(0),0) 
  end if
end sub

DPF(CompileShaderARB) ' hShader
  if glCompileShaderARB<>0 then
    glCompileShaderARB(GIP(1))
  end if
end sub

DPF(AttachObjectARB)' hProgram,hShader
  if gIsInit then
    glAttachObjectARB(GIP(2),GIP(1))
  end if
end sub

DPF(LinkProgramARB) ' hProgram
  if gIsInit then
    glLinkProgramARB(GIP(1))
  end if
end sub

DPF(ValidateProgramARB) ' hProgram
  glValidateProgramARB(GIP(1))
end sub

DPF(UseProgramObjectARB) ' hProgram
  if gIsInit then
    glUseProgramObjectARB(GIP(1))
  end if
end sub

DPF(DetachObjectARB)' hProgram,hShader
  if gIsInit then
    glDetachObjectARB(GIP(2),GIP(1))
  end if
end sub

DPF(GetObjectParameterivARB) ' hObject,const,&ret)
  dim as integer ret
  glGetObjectParameterivARB(GIP(3),GIP(2),@ret)
  SIPR(1,@ret)
end sub

DPF(GetObjectParameterfvARB) ' hObject,const,&ret#)
  dim as single ret
  glGetObjectParameterfvARB(GIP(3),GIP(2),@ret)
  SFPR(1,@ret)
end sub

DPF(GetUniformLocationARB) ' pos=(hProgram,Name$)
  dim as zstring ptr pName=GSP(1)
  SIR(glGetUniformLocationARB(GIP(2),pName))
end sub

' Get/Set shader vars
DPF(GetUniformivARB) ' hProgram,location,var)
  dim as integer ret
  glGetUniformivARB(GIP(3),GIP(2),@ret)
  SIPR(1,@ret)
end sub
DPF(GetUniformfvARB) ' hProgram,location,var#)
  dim as single ret
  glGetUniformfvARB(GIP(3),GIP(2),@ret)
  SIPR(1,@ret)
end sub

DPF(Uniform1fARB)
  glUniform1fARB(GIP(2),GFP(1))
end sub
DPF(Uniform2fARB)
  glUniform2fARB(GIP(3),GFP(2),GFP(1))
end sub
DPF(Uniform3fARB)
  glUniform3fARB(GIP(4),GFP(3),GFP(2),GFP(1))
end sub
DPF(Uniform4fARB)
  glUniform4fARB(GIP(5),GFP(4),GFP(3),GFP(2),GFP(1))
end sub

DPF(Uniform1iARB)
  glUniform1iARB(GIP(2),GIP(1))
end sub
DPF(Uniform2iARB)
  glUniform2iARB(GIP(3),GIP(2),GIP(1))
end sub
DPF(Uniform3iARB)
  glUniform3iARB(GIP(4),GIP(3),GIP(2),GIP(1))
end sub
DPF(Uniform4iARB)
  glUniform4iARB(GIP(5),GIP(4),GIP(3),GIP(2),GIP(1))
end sub

DPF(Uniform1ivARB) ' location,n,array()
  dim as integer nInts=GIP(2)
  dim as integer ptr pArray=allocate(nInts*4)
  GIA(1,pArray,nInts)
  glUniform1ivARB(GIP(3),nInts,pArray)
  deallocate pArray
end sub
DPF(Uniform2ivARB) ' location,n,array(n)(1)
  dim as integer nInts=GIP(2)
  dim as integer ptr pArray=allocate(nInts*4*2)
  GIA2D(1,pArray,nInts,2)
  glUniform2ivARB(GIP(3),nInts,pArray)
  deallocate pArray
end sub
DPF(Uniform3ivARB) ' location,n,array(n)(2)
  dim as integer nInts=GIP(2)
  dim as integer ptr pArray=allocate(nInts*4*3)
  GIA2D(1,pArray,nInts,3)
  glUniform3ivARB(GIP(3),nInts,pArray)
  deallocate pArray
end sub
DPF(Uniform4ivARB) ' location,n,array(n)(3)
  dim as integer nInts=GIP(2)
  dim as integer ptr pArray=allocate(nInts*4*4)
  GIA2D(1,pArray,nInts,4)
  glUniform4ivARB(GIP(3),nInts,pArray)
  deallocate pArray
end sub

DPF(Uniform1fvARB) ' location,n,array#()
  dim as integer nFloats=GIP(2)
  dim as single ptr pArray=allocate(nFloats*4)
  GFA(1,pArray,nFloats)
  glUniform1fvARB(GIP(3),nFloats,pArray)
  deallocate pArray
end sub
DPF(Uniform2fvARB) ' location,n,array#(n)(1)
  dim as integer nFloats=GIP(2)
  dim as single ptr pArray=allocate(nFloats*4*2)
  GFA2D(1,pArray,nFloats,2)
  glUniform2fvARB(GIP(3),nFloats,pArray)
  deallocate pArray
end sub
DPF(Uniform3fvARB) ' location,n,array#(n)(2)
  dim as integer nFloats=GIP(2)
  dim as single ptr pArray=allocate(nFloats*4*3)
  GFA2D(1,pArray,nFloats,3)
  glUniform3fvARB(GIP(3),nFloats,pArray)
  deallocate pArray
end sub
DPF(Uniform4fvARB) ' location,n,array#(n)(3)
  dim as integer nFloats=GIP(2)
  dim as single ptr pArray=allocate(nFloats*4*4)
  GFA2D(1,pArray,nFloats,4)
  glUniform4fvARB(GIP(3),nFloats,pArray)
  deallocate pArray
end sub

DPF(SwapIntervalEXT)
  if wglSwapIntervalEXT<>0 then
    wglSwapIntervalEXT(GIP(1))
  end if
end sub

' ##########
' # Plugin #
' ##########
function Load(THIS_PLUGIN  , _
              THIS_REGISTRY, _
              blnIsExe as byte) as byte
  
  RIC2("GL_VERTEX_SHADER"             ,GL_VERTEX_SHADER)
  RIC2("GL_FRAGMENT_SHADER"           ,GL_FRAGMENT_SHADER)
  RIC2("GL_SHADING_LANGUAGE_VERSION"  ,GL_SHADING_LANGUAGE_VERSION)
  RIC2("GL_VERTEX_SHADER_ARB"         ,GL_VERTEX_SHADER_ARB)
  RIC2("GL_FRAGMENT_SHADER_ARB"       ,GL_FRAGMENT_SHADER_ARB)
  RIC2("GL_OBJECT_LINK_STATUS_ARB"    ,GL_OBJECT_LINK_STATUS_ARB)
  RIC2("GL_OBJECT_COMPILE_STATUS_ARB" ,GL_OBJECT_COMPILE_STATUS_ARB)
  RIC2("GL_OBJECT_VALIDATE_STATUS_ARB",GL_OBJECT_VALIDATE_STATUS_ARB)
  RIC2("GL_OBJECT_DELETE_STATUS_ARB"  ,GL_OBJECT_DELETE_STATUS_ARB)
  RIC2("GL_OBJECT_INFO_LOG_LENGTH_ARB",GL_OBJECT_INFO_LOG_LENGTH_ARB)
  RIC2("GL_OBJECT_ACTIVE_UNIFORMS_ARB",GL_OBJECT_ACTIVE_UNIFORMS_ARB)
  RIC2("GL_ACTIVE_UNIFORM_MAX_LENGTH" ,GL_ACTIVE_UNIFORM_MAX_LENGTH )
  RIC2("GL_OBJECT_TYPE_ARB"           ,GL_OBJECT_TYPE_ARB)
  RIC2("GL_OBJECT_SUBTYPE_ARB"        ,GL_OBJECT_SUBTYPE_ARB)
  RIC2("GL_PROGRAM_OBJECT_ARB"        ,GL_PROGRAM_OBJECT_ARB)
  RIC2("GL_OBJECT_ATTACHED_OBJECTS_ARB",GL_OBJECT_ATTACHED_OBJECTS_ARB)
  RIC2("GL_OBJECT_SHADER_SOURCE_LENGTH_ARB",GL_OBJECT_SHADER_SOURCE_LENGTH_ARB)

  RIC2("GL_FLOAT",GL_FLOAT)
  RIC2("GL_FLOAT_VEC2_ARB",GL_FLOAT_VEC2_ARB)
  RIC2("GL_FLOAT_VEC3_ARB",GL_FLOAT_VEC3_ARB)
  RIC2("GL_FLOAT_VEC4_ARB",GL_FLOAT_VEC4_ARB)
  RIC2("GL_INT",GL_INT)
  RIC2("GL_INT_VEC2_ARB",GL_INT_VEC2_ARB)
  RIC2("GL_INT_VEC3_ARB",GL_INT_VEC3_ARB)
  RIC2("GL_INT_VEC4_ARB",GL_INT_VEC4_ARB)
  RIC2("GL_BOOL_ARB",GL_BOOL_ARB)
  RIC2("GL_BOOL_VEC2_ARB",GL_BOOL_VEC2_ARB)
  RIC2("GL_BOOL_VEC3_ARB",GL_BOOL_VEC3_ARB)
  RIC2("GL_BOOL_VEC4_ARB",GL_BOOL_VEC4_ARB)
  RIC2("GL_FLOAT_MAT2_ARB",GL_FLOAT_MAT2_ARB)
  RIC2("GL_FLOAT_MAT3_ARB",GL_FLOAT_MAT3_ARB)
  RIC2("GL_FLOAT_MAT4_ARB",GL_FLOAT_MAT4_ARB)
  RIC2("GL_SAMPLER_1D_ARB",GL_SAMPLER_1D_ARB)
  RIC2("GL_SAMPLER_2D_ARB",GL_SAMPLER_2D_ARB)
  RIC2("GL_SAMPLER_3D_ARB",GL_SAMPLER_3D_ARB)
  RIC2("GL_SAMPLER_CUBE_ARB",GL_SAMPLER_CUBE_ARB)
  RIC2("GL_SAMPLER_1D_SHADOW_ARB",GL_SAMPLER_1D_SHADOW_ARB)
  RIC2("GL_SAMPLER_2D_SHADOW_ARB",GL_SAMPLER_2D_SHADOW_ARB)
  RIC2("GL_SAMPLER_2D_RECT_ARB",GL_SAMPLER_2D_RECT_ARB)
  RIC2("GL_SAMPLER_2D_RECT_SHADOW_ARB",GL_SAMPLER_2D_RECT_SHADOW_ARB)

  RIF(ShaderInit)
  RIF(CompileStatus):AIP
  RIF(LinkStatus):AIP
  RIF(ValidateStatus):AIP
  RSF(GetInfoLog):AIP
  RIF(GetActiveUniforms):AIP
  RSF(GetUniformName):AIP:AIP
  RIF(GetUniformType):AIP:AIP

  RIF2("glCreateShaderObjectARB",CreateShaderObjectARB):AIP
  RVF2("glShaderSourceARB",ShaderSourceARB):AIP:ASP
  RVF2("glCompileShaderARB",CompileShaderARB):AIP
  
  RIF2("glCreateProgramObjectARB",CreateProgramObjectARB)
  RVF2("glAttachObjectARB",AttachObjectARB):AIP:AIP
  RVF2("glLinkProgramARB",LinkProgramARB):AIP
  RVF2("glValidateProgramARB",ValidateProgramARB):AIP

  RVF2("glUseProgramObjectARB",UseProgramObjectARB):AIP

  RVF2("glDetachObjectARB",DetachObjectARB):AIP:AIP
  RVF2("glDeleteObjectARB",DeleteObjectARB):AIP

  RVF2("glGetObjectParameterivARB",GetObjectParameterivARB):AIP:AIP:AIPR
  RVF2("glGetObjectParameterfvARB",GetObjectParameterfvARB):AIP:AIP:AFPR
  
  RIF2("glGetUniformLocationARB",GetUniformLocationARB):AIP:ASP

  RVF2("glGetUniformivARB",GetUniformivARB)
  RVF2("glGetUniformfvARB",GetUniformfvARB)

  RVF2("glUniform1iARB",Uniform1iARB):AIP: AIP
  RVF2("glUniform2iARB",Uniform2iARB):AIP: AIP:AIP
  RVF2("glUniform3iARB",Uniform3iARB):AIP: AIP:AIP:AIP
  RVF2("glUniform4iARB",Uniform4iARB):AIP: AIP:AIP:AIP:AIP
  
  RVF2("glUniform1fARB",Uniform1fARB):AIP: AFP
  RVF2("glUniform2fARB",Uniform2fARB):AIP: AFP:AFP
  RVF2("glUniform3fARB",Uniform3fARB):AIP: AFP:AFP:AFP
  RVF2("glUniform4fARB",Uniform4fARB):AIP: AFP:AFP:AFP:AFP 

  RVF2("glUniform1ivARB",Uniform1ivARB):AIP: AIP:AAIP(1)
  RVF2("glUniform2ivARB",Uniform2ivARB):AIP: AIP:AAIP(2)
  RVF2("glUniform3ivARB",Uniform3ivARB):AIP: AIP:AAIP(2)
  RVF2("glUniform4ivARB",Uniform4ivARB):AIP: AIP:AAIP(2)

  RVF2("glUniform1fvARB",Uniform1fvARB):AIP: AIP:AAFP(1)
  RVF2("glUniform2fvARB",Uniform2fvARB):AIP: AIP:AAFP(2)
  RVF2("glUniform3fvARB",Uniform3fvARB):AIP: AIP:AAFP(2)
  RVF2("glUniform4fvARB",Uniform4fvARB):AIP: AIP:AAFP(2)

  RVF2("wglSwapIntervalEXT",SwapIntervalEXT):AIP

  return 1
end function

sub      Unload (THIS_PLUGIN)
  delete Plugin
end sub

function Start (THIS_PLUGIN) as byte
  if gIsInit=0 then

    LGP(glCreateShaderObjectARB)
    LGP(glShaderSourceARB)
    LGP(glCompileShaderARB)
    LGP(glDeleteObjectARB)
    LGP(glCreateProgramObjectARB)
    LGP(glAttachObjectARB)
    LGP(glDetachObjectARB)
    LGP(glUseProgramObjectARB)
    LGP(glLinkProgramARB)
    LGP(glValidateProgramARB)
    LGP(glGetInfoLogARB)
    LGP(glGetObjectParameterivARB)
    LGP(glGetObjectParameterfvARB)
    LGP(glGetActiveUniformARB)
    LGP(glGetShaderSourceARB)
    LGP(glGetAttachedObjectsARB)

    LGP(glGetUniformLocationARB)
    LGP(glGetUniformivARB)
    LGP(glGetUniformfvARB)

    LGP(glUniform1fARB)
    LGP(glUniform2fARB)
    LGP(glUniform3fARB)
    LGP(glUniform4fARB)

    LGP(glUniform1iARB)
    LGP(glUniform2iARB)
    LGP(glUniform3iARB)
    LGP(glUniform4iARB)

    LGP(glUniform1fvARB)
    LGP(glUniform2fvARB)
    LGP(glUniform3fvARB)
    LGP(glUniform4fvARB)

    LGP(glUniform1ivARB)
    LGP(glUniform2ivARB)
    LGP(glUniform3ivARB)
    LGP(glUniform4ivARB)

    LGP(glUniformMatrix2fvARB)
    LGP(glUniformMatrix3fvARB)
    LGP(glUniformMatrix4fvARB)

    LGP(glGetUniformfvARB)
    LGP(glGetUniformivARB)
   
    wglSwapIntervalEXT = cptr(any ptr,wglGetProcAddress("wglSwapIntervalEXT"))

    if glCreateShaderObjectARB  = 0 or _
      glShaderSourceARB         = 0 or _
      glCompileShaderARB        = 0 or _
      glDeleteObjectARB         = 0 or _
      glCreateProgramObjectARB  = 0 or _
      glAttachObjectARB         = 0 or _
      glDetachObjectARB         = 0 or _
      glUseProgramObjectARB     = 0 or _
      glLinkProgramARB          = 0 or _
      glValidateProgramARB      = 0 or _
      glGetObjectParameterivARB = 0 or _
      glGetObjectParameterfvARB = 0 or _
      glGetInfoLogARB           = 0 then
      gLastError="no GL_ARB_shader_support !"
      gIsInit=0
      beep
    else
      gIsInit=1
    end if
  end if
  return gIsInit
end function

sub      Ends (THIS_PLUGIN)
  
end sub
sub      Pause (THIS_PLUGIN)

end sub
sub      Resumed (THIS_PLUGIN)

end sub
sub      DelayedResume (THIS_PLUGIN)

end sub
sub      GetError  (THIS_PLUGIN,pErrMsg as zstring ptr)
  dim as integer i,l=len(gLastError)
  if l then
    for i=0 to l-1
      pErrMsg[i]=gLastError[i]
    next
   pErrMsg[i]=0
  end if
end sub
sub      ProcessMessages(THIS_PLUGIN)

end sub

' Query function
function Basic4GL_Query  (byval details as string, _
                          byref major   as integer, _
                          byref minor   as integer) as integer export
  dim as string detailSrc = PLUG_DESC
  for i as integer = 0 to len(detailSrc)
    details[i] = detailSrc[i]
  next
  major = PLUG_MAJOR
  minor = PLUG_MINOR
  return BASIC4GL_DLL_VERSION
end function



' Main initialisation function.
' Here we will construct and return our plugin object
function Basic4GL_Init () as IDLL_Basic4GL_Plugin ptr ptr export
  Plugin=new IDLL_Basic4GL_Plugin
  ' Construct and return our plugin object
  Plugin->Load           =@Load
  Plugin->Unload         =@Unload
  Plugin->Start          =@Start
  Plugin->Ends           =@Ends
  Plugin->Pause          =@Pause
  Plugin->Resumed        =@Resumed
  Plugin->DelayedResume  =@DelayedResume
  Plugin->GetError       =@GetError
  Plugin->ProcessMessages=@ProcessMessages
  return @Plugin
end function

end extern
